<template>
  <div class="row">
    <transition-group enter-active-class="animated fadeIn">
    <post v-for="(post, index) in posts" 
      :key="post"
      :post="post"
      :index="index"
      @postDelete="deletePost($event)">
    </post>
  </transition-group>
  <div class="col-md-offset-2 col-md-8">
    <button type="button" 
      class="btn btn-primary btn-lg btn-block"
      :disabled="!next_page"
      @click='loadMore()'>Load more</button>
  </div>
 </div>
</template>

<script>

import Post from './Post'

export default {
  name: 'PostList',
  components: {
    Post
  },
  data () {
    return {
      posts: [],
      next_page: ''
    }
  },
  computed: {
    auth () {
      return this.$store.getters.isAuthenticated
    }
  },
  watch: {
    '$route' (to, from) {
      this.posts = []
      if (to.query.tag) {
        this.getPostList(undefined, to.query.tag)
      } else {
        this.getPostList()
      }
    }
  },
  methods: {
    slugDate (date) {
      return this.$moment(date).utc().format('YYYY-MM-DD')
    },
    loadMore () {
      this.getPostList(this.next_page)
    },
    getPostList (url = 'blog/post', tag) {
      if (tag) {
        url = `${url}?tag=${tag}`
      }
      this.$http.get(url)
        .then(response => {
          this.posts = this.posts.concat(response.body.data)
          this.next_page = response.body.next_page
          if (tag && this.next_page) {
            this.next_page = `${this.next_page}&tag=${tag}`
          }
        }, () => {
          let type = 'danger'
          let message = 'Nothing found'
          this.$store.commit('addAlert', {type, message})
        })
    },
    postDelete (event) {
      console.log(event.id, event.index)
    },
    deletePost (event) {
      this.$http.delete(`blog/post/${event.id}`)
      .then(response => {
        this.posts.splice(event.index, 1)
      }, error => {
        console.log(error)
      })
    }
  },
  created () {
    this.getPostList()
  }
}
</script>

<style scoped>
</style>
